local screen_x_y = MODEL.screen.width() .. "_" .. MODEL.screen.height()
  SetDynamicLuaVarsScript = "sc_SetDynamicLuaVars_480_320"
  gJunctionViewDirectory = "480_320_Lanes"
 
sc_SetDynamicLuaVars_480_320 = function()
  if MODEL.screen.current_orientation_mode() == OrientationMode.Landscape then
    scripts = {TMCMapSize = var.tuple(66, 90, 387, 150)}
    Blend = {TrafficMapDetails_y = var.tuple(0, 57), EasyTMCMapControl_x = var.tuple(0, -78), rightcontrols_sublayer_y = var.tuple(75, 135)}
    RecalcMsgPos = {EasyRouteMenu = var.tuple(123, 3), MyRouteMenu = var.tuple(12, 60), AvoidItinerEntry = var.tuple(129, 129), RouteItiner = var.tuple(129, 117), AvoidancesMenu = var.tuple(130, 141)}
  elseif MODEL.screen.current_orientation_mode() == OrientationMode.Portrait then
    scripts = {TMCMapSize = var.tuple(73, 126, 173, 272)}
    Blend = {TrafficMapDetails_y = var.tuple(0, 51), EasyTMCMapControl_x = var.tuple(0, -70), rightcontrols_sublayer_y = var.tuple(91, 126)}
    RecalcMsgPos = {EasyRouteMenu = var.tuple(37, 3), MyRouteMenu = var.tuple(13, 81), AvoidItinerEntry = var.tuple(37, 224), RouteItiner = var.tuple(37, 213), AvoidancesMenu = var.tuple(37, 224)}
  end
end
 
 
sc_SetDynamicLuaVars = function(orientation)
  if orientation ~= last_orientation then
    _G[SetDynamicLuaVarsScript]()
    last_orientation = orientation
  end
end
 
OrientationMode = {Landscape = 1, Portrait = 2}
HTML_folder = "480_272"
CREDITS_folder = "480_272"
headerLinePad = 5
gMoreMenuMargin = 24
gMoreMenuStep = 4
gMoreMenuScreenWith = 432
gMoreMenuWidth = gMoreMenuScreenWith / gMoreMenuStep
gMapMessageBoxY = 36
gMapMessageBoxYwithStart = 46
gJunctionViewDirectory = "480_320_Lanes|480_320_Lanes"
gJunctionViewContentResolution = "480x272|640x320"
gEjv_landscape_w = 480
gEjv_landscape_h = 272
gEjv_portrait_w = 640
gEjv_portrait_h = 320
gJv_landscape_w = 480
gJv_landscape_h = 272
gJv_portrait_w = 640
gJv_portrait_h = 320
gJVPatch_Offset = 164
gJV_w = nil
gJV_h = nil
sc_set_TMCMapSize = function()
  local x, y, w, h = var.unpack(scripts.TMCMapSize)
  ETmcMapSize = {x = x, y = y, w = w, h = h}
end
 
sc_setupTransitions = function()
  local orientation_mode = MODEL.screen.current_orientation_mode()
  if orientation_mode == OrientationMode.Landscape then
    trMM_map = "0:x=16;y=23;w=122;h=126|100:x=0;y=0;w=480;h=295|"
  elseif orientation_mode == OrientationMode.Portrait then
    trMM_map = "0:x=18;y=31;w=283;h=113|100:x=0;y=0;w=320;h=456|"
  end
end
 
SpeedlimitW = 51
SpeedlimitH = 38
USASpeedlimitW = 46
USASpeedlimitH = 52
SpeedcamW = 57
SpeedcamH = 38
SpeedcamSpeedlimitW = 61
SpeedcamSpeedlimitH = 62
DAiconIdx = 0
TMCIconIndex =  0
msgboxFlagIconIndex = 0
SatAnimRadius = 33
sc_SpeedCam_SetMapCenter = function()
  local mapLayer = MODEL.map.primary
  local orientation_mode = MODEL.screen.current_orientation_mode()
  if orientation_mode == OrientationMode.Landscape then
    mapLayer.center_posx = 40
    mapLayer.center_posy = 63
  elseif orientation_mode == OrientationMode.Portrait then
    mapLayer.center_posx = 50
    mapLayer.center_posy = 65
  end
end
 
set_resolution = function()
  uiResW = MODEL.screen.width()
  uiResH = MODEL.screen.height()
end
 
sc_mainmenu_set_smallmap = function()
  local map_w = ui.smallmap_showmap.W / 4 * 4
  local map_h = ui.smallmap_showmap.H / 4 * 4
  local map_x = ui.smallmap_showmap.X + (ui.smallmap_showmap.W - map_w) / 2
  local map_y = ui.smallmap_showmap.Y + (ui.smallmap_showmap.H - map_h) / 2
  primary.X, primary.Y, primary.W, primary.H = map_x, map_y, map_w, map_h
  primary.Z = 40
  MODEL.map.primary.show_labels_3d = false
  MODEL.map.primary.show_labels_2d = false
end
 
sc_set_smallmap_WhereAmI = function()
  local map_w = ui.smallmap_whereami.W / 4 * 4
  local map_h = ui.smallmap_whereami.H / 4 * 4
  local map_x = ui.smallmap_whereami.X + (ui.smallmap_whereami.W - map_w) / 2
  local map_y = ui.smallmap_whereami.Y + (ui.smallmap_whereami.H - map_h) / 2
  primary.X, primary.Y, primary.W, primary.H = map_x, map_y, map_w, map_h
  primary.Z = 35
end
 
sc_set_smallmap_ColorScheme = function()
  local map_w = ui.smallmap_colorscheme.W / 4 * 4
  local map_h = ui.smallmap_colorscheme.H / 4 * 4
  local map_x = ui.smallmap_colorscheme.X + (ui.smallmap_colorscheme.W - map_w) / 2
  local map_y = ui.smallmap_colorscheme.Y + (ui.smallmap_colorscheme.H - map_h) / 2
  primary.X, primary.Y, primary.W, primary.H = map_x, map_y, map_w, map_h
  primary.Z = 35
end
 
sc_routemenu_info_fit_open_from_main = function(topLeft, bottomRight)
  MODEL.map.primary.mode = "2d"
  local fit = MODEL.map.primary.fit
  local orientation_mode = MODEL.screen.current_orientation_mode()
  if st_CurrentTraffic.isActive then
    fit.x = ui.fitbox_currenttraffic.X
    fit.y = ui.fitbox_currenttraffic.Y
    fit.w = ui.fitbox_currenttraffic.W
    fit.h = ui.fitbox_currenttraffic.H
  elseif st_HistoricalView.isActive then
    fit.x = ui.fitbox_historicaltraffic.X
    fit.y = ui.fitbox_historicaltraffic.Y
    fit.w = ui.fitbox_historicaltraffic.W
    fit.h = ui.fitbox_historicaltraffic.H
  elseif st_EasyRouteMethod.isActive then
    fit.x = ui.fitbox_routemethod.X
    fit.y = ui.fitbox_routemethod.Y
    fit.w = ui.fitbox_routemethod.W
    fit.h = ui.fitbox_routemethod.H
  else
    fit.x = ui.fitbox_routemenu.X
    fit.y = ui.fitbox_routemenu.Y
    fit.w = ui.fitbox_routemenu.W
    fit.h = ui.fitbox_routemenu.H
  end
  sc_fit_to_screen_delay(topLeft, bottomRight)
  MODEL.lua.TempMapCenter = MODEL.map.primary.center()
  MODEL.lua.TempMapZoom = MODEL.map.primary.zoom()
end
 
sc_fit_avoid = function(topLeft, bottomRight)
  if st_AvoidRouteAhead.isActive then
    sc_fit_general(topLeft, bottomRight, ui.fitbox_avoid_ahead.X, ui.fitbox_avoid_ahead.Y, ui.fitbox_avoid_ahead.W, ui.fitbox_avoid_ahead.H)
  else
    sc_fit_general(topLeft, bottomRight, ui.fitbox_avoid.X, ui.fitbox_avoid.Y, ui.fitbox_avoid.W, ui.fitbox_avoid.H)
  end
end
 
sc_fit_traffic_detour = function(topLeft, bottomRight)
  sc_fit_general(topLeft, bottomRight, ui.fitbox_trafficdetour.X, ui.fitbox_trafficdetour.Y, ui.fitbox_trafficdetour.W, ui.fitbox_trafficdetour.H)
end
 
sc_fit_parking = function(topLeft, bottomRight)
  doDelayed(1, function()
    sc_fit_general(l_14_0, l_14_1, ui.fitbox_resultpoi.X, ui.fitbox_resultpoi.Y, ui.fitbox_resultpoi.W, ui.fitbox_resultpoi.H)
  end
  )
end
 
sc_GetMoreMenuAnim = function(X, Y)
  return "0:x=" .. X .. ";y=" .. Y .. ";w=105;h=98|100:x=0;y=0;w=400;h=320|"
end
 
sc_SetSignalH = function(signal)
  local h = float.new(signal) / 50
  return h
end
 
sc_SetSignalY = function(signal)
  local orientation_mode = MODEL.screen.current_orientation_mode()
  if orientation_mode == OrientationMode.Landscape then
    local h = 153 * (float.new(signal) / 50)
    return 289 - h:toInt()
  else
    local h = 153 * (float.new(signal) / 50)
    return 578 - h:toInt()
  end
end
 
sc_SetSignalPos = function(listsize, width, cellw)
  local pos = 0
  pos = width / 2 - listsize * cellw / 2
  return pos
end
 
sc_PosRecalcLayer = function()
  if st_EasyRouteMenu.isActive then
    local l_21_0 = ui_RecalcMsgBox
    l_21_0.X, ui_RecalcMsgBox.Y = var.unpack(RecalcMsgPos.EasyRouteMenu)
  elseif st_MyRouteMenu.isActive then
    local l_21_1 = ui_RecalcMsgBox
    l_21_1.X, ui_RecalcMsgBox.Y = var.unpack(RecalcMsgPos.MyRouteMenu)
  elseif st_AvoidItinerEntry.isActive then
    local l_21_2 = ui_RecalcMsgBox
    l_21_2.X, ui_RecalcMsgBox.Y = var.unpack(RecalcMsgPos.AvoidItinerEntry)
  elseif st_RouteItiner.isActive or st_RouteParamsWithWarnings_Route.isActive then
    local l_21_3 = ui_RecalcMsgBox
    l_21_3.X, ui_RecalcMsgBox.Y = var.unpack(RecalcMsgPos.RouteItiner)
  elseif st_AvoidancesMenu.isActive then
    local l_21_4 = ui_RecalcMsgBox
    l_21_4.X, ui_RecalcMsgBox.Y = var.unpack(RecalcMsgPos.AvoidancesMenu)
  end
end
 
sc_SelectMapCursor = function()
  local CursorIcon = MODEL.map.primary.cursor_icon()
  if CursorIcon == "cursor_places" then
    return "ico_cursorhead_place.bmp"
  elseif CursorIcon == "cursor_poi" or CursorIcon == "cursor_poi_brand" then
    return ""
  elseif CursorIcon == "cursor_tmc" then
    return "ico_cursorhead_tmc.bmp"
  else
    return "ico_cursorhead_cursor.bmp"
  end
end
 
sc_fit_blockedroad = function()
  local topLeft, bottomRight = MODEL.mydata.blocked_roads.get_boundrect()
  sc_fit_general(topLeft, bottomRight, ui.fitbox_blockedroad.X, ui.fitbox_blockedroad.Y, ui.fitbox_blockedroad.W, ui.fitbox_blockedroad.H)
  MODEL.lua.TempMapCenter = MODEL.map.primary.center()
  MODEL.lua.TempMapZoom = MODEL.map.primary.zoom()
end
 
sc_fit_tracklog = function(topLeft, bottomRight, trackmode)
  local orientation_mode = MODEL.screen.current_orientation_mode()
  if trackmode == 1 then
    MODEL.map.primary.center_posy = 65
    sc_fit_general(topLeft, bottomRight, ui.fitbox_trackoverviewmap.X, ui.fitbox_trackoverviewmap.Y, ui.fitbox_trackoverviewmap.W, ui.fitbox_trackoverviewmap.H)
  else
    sc_fit_general(topLeft, bottomRight, ui.fitbox_trackoverview.X, ui.fitbox_trackoverview.Y, ui.fitbox_trackoverview.W, ui.fitbox_trackoverview.H)
  end
end
 
sc_fit_itinerboxsize = function()
  local fit = MODEL.map.primary.fit
  fit.x, fit.y, fit.w, fit.h = ui.fitbox_itiner.X, ui.fitbox_itiner.Y, ui.fitbox_itiner.W, ui.fitbox_itiner.H
end
 
sc_OpenTrafficMapDetailsAdjustable = function(dt)
  MODEL.lua.TrafficMapDetailsOpen = true
  local from, to = var.unpack(Blend.TrafficMapDetails_y)
  ui_TrafficMapDetails:YBLEND(from, to, dt)
  from, to = var.unpack(Blend.EasyTMCMapControl_x)
  ui_EasyTMCMapControls:XBLEND(from, to, dt)
  from, to = var.unpack(Blend.rightcontrols_sublayer_y)
  ui_rightcontrols_sublayer:YBLEND(from, to, dt)
end
 
sc_CloseTrafficMapDetailsAdjustable = function(dt)
  MODEL.lua.TrafficMapDetailsOpen = false
  local to, from = var.unpack(Blend.TrafficMapDetails_y)
  ui_TrafficMapDetails:YBLEND(from, to, dt)
  to, from = var.unpack(Blend.EasyTMCMapControl_x)
  ui_EasyTMCMapControls:XBLEND(from, to, dt)
  to, from = var.unpack(Blend.rightcontrols_sublayer_y)
  ui_rightcontrols_sublayer:YBLEND(from, to, dt)
end
 
sc_OpenTrafficMapDetails = function()
  sc_OpenTrafficMapDetailsAdjustable(15)
end
 
sc_InstantOpenTrafficMapDetails = function()
  sc_OpenTrafficMapDetailsAdjustable(0)
end
 
sc_CloseTrafficMapDetails = function()
  sc_CloseTrafficMapDetailsAdjustable(15)
end
 
sc_InstantCloseTrafficMapDetails = function()
  sc_CloseTrafficMapDetailsAdjustable(0)
end
 
sc_SetPictureSize = function()
  if MODEL.lua.pictloadhq() then
    spr_Pict:PICTW(2048)
    spr_Pict:PICTH(2048)
    spr_PictOne:PICTW(2048)
    spr_PictOne:PICTH(2048)
  else
    spr_Pict:PICTW(360)
    spr_Pict:PICTH(190)
    spr_PictOne:PICTW(360)
    spr_PictOne:PICTH(190)
  end
end
 
sc_SetFullScreenPictureSize = function()
  if MODEL.lua.pictloadhq() then
    spr_PictSlideShow:PICTW(2048)
    spr_PictSlideShow:PICTH(2048)
  else
    spr_PictSlideShow:PICTW(480)
    spr_PictSlideShow:PICTH(320)
  end
end
 
sc_SetSlideShowDemo = function()
  ui_PictSettings_SlideShowDemo.PictureW = 193
  ui_PictSettings_SlideShowDemo.PictureH = 211
end
 
sc_set_AdvMenuLayerPos = function()
  MODEL.lua.layerpos = 23
end
 
sc_GetLocalMenuBgY = function(size)
  local resultY = 160
  if size == 1 then
    resultY = 160
  elseif size == 2 then
    resultY = 99
  elseif size == 3 then
    resultY = 38
  end
  return resultY
end
 
sc_GetDemoTextH = function()
  ui_Demo_XHTML.W = 460
  ForceRefreshLayer(ui_Demo_XHTML)
  if MODEL.ui.ui_Demo_XHTML.can_scroll_up() or MODEL.ui.ui_Demo_XHTML.can_scroll_down() then
    ui_Demo_XHTML.W = 420
    ForceRefreshLayer(ui_Demo_XHTML)
  end
end
 
sc_ViaPositionSim = function(index, height)
  if MODEL.navigation.distance_total() > 0 then
    local pos = QWORD.new(MODEL.navigation.distance_to_destination() - MODEL.route.list.navigated.waypoints.list[index].total_length()) * height / MODEL.navigation.distance_total()
    pos = pos:toInt()
    return pos
  end
  return -100
end
 
sc_ViaPosition = function(index, height)
  if index > 0 and index < #MODEL.route.list.navigated.waypoints.list - 1 then
    local pos = QWORD.new(MODEL.route.list.navigated.waypoints.list[MODEL.route.list.navigated.waypoints.list.lastindex()].total_length() - MODEL.route.list.navigated.waypoints.list[index].total_length()) * height / (MODEL.navigation.distance_to_destination() + MODEL.other.trips[0].distance_total())
    pos = pos:toInt()
    return pos
  end
  return -100
end
 
sc_FitComparedRoutes = function(topLeft, bottomRight)
  if not topLeft:IsValid() or not bottomRight:IsValid() then
    return 
  end
  MODEL.map.primary.mode = "2d"
  MODEL.map.primary.fit.x = 55
  MODEL.map.primary.fit.y = 70
  MODEL.map.primary.fit.w = 225
  MODEL.map.primary.fit.h = 160
  local globe = MODEL.map.primary.fit.globe_enabled()
  MODEL.map.primary.fit.globe_enabled = true
  MODEL.map.primary.fit.show(topLeft, bottomRight)
  MODEL.map.primary.fit.globe_enabled = globe
  MODEL.lua.TempMapCenter = MODEL.map.primary.center()
  MODEL.lua.TempMapZoom = MODEL.map.primary.zoom()
end
 
sc_SetCountrySpecTMCIcon = function()
  local ID = MODEL.traffic.events.regionalize_icon(1000, MODEL.gps.position())
  gCountySpecTMCIcon = MODEL.screen.get_icon_file_and_phase(ID, 2)
  gCountySpecTMCIcon_Disabled = MODEL.screen.get_icon_file_and_phase(ID, 3)
end
 
sc_SetCockpitMap = function()
end
 
sc_getKeyLeft12 = function(keyindex)
  return 63 * keyindex
end
 
sc_getMoreMenuBtnBmp = function(i)
  local index = i + 1
  local size = MODEL["*"]._list.size()
  if index == 1 then
    return "button_topleft.bmp#3"
  elseif index == size then
    return "button_bottomright.bmp#3"
  else
    return "button.bmp#3"
  end
end
 
sc_getPicViewerBtnBmp = function(i)
  local index = i + 1
  local residuum = index % 8
  if residuum == 1 then
    return "button_topleft.bmp#3"
  elseif residuum == 0 then
    return "button_bottomright.bmp#3"
  else
    return "button.bmp#3"
  end
end
 
sc_getSlapiDMenuBtnBmp = function(i, isLeft, isCheckbox)
  local index = i + 1
  local size = MODEL["*"]._list.size()
  if index == 1 and isLeft then
    if isCheckbox then
      return "button_topleft_nopress.bmp#3"
    else
      return "button_topleft.bmp#3"
    end
  elseif index == size and not isLeft then
    if isCheckbox then
      return "button_bottomright_nopress.bmp#3"
    else
      return "button_bottomright.bmp#3"
    end
  elseif isCheckbox then
    return "button_nopress.bmp#3"
  else
    return "button.bmp#3"
  end
end
 
sc_SetVRBackground = function(status)
  if MODEL.EXISTS.vr() then
    if MODEL.lua.VRError() then
      return "vr_error_bg.bmp"
    end
    if status == eVRStatus.listen then
      if MODEL.vr.engine_state() == 1 then
        return "vr_talk_bg.bmp"
      else
        return "vr_listen_bg.bmp"
      end
    elseif status == eVRStatus.click then
      return "vr_click_bg.bmp"
    else
      return "vr_click_bg.bmp"
    end
  end
  return "vr_click_bg.bmp"
end
 
sc_SetVRMessageboxBackground = function(status)
  if MODEL.EXISTS.vr() then
    if MODEL.lua.VRError() then
      return "msgbox_vr_error_bg_skincol.bmp"
    end
    if status == eVRStatus.listen then
      if MODEL.vr.engine_state() == 1 then
        return "msgbox_vr_talk_bg_skincol.bmp"
      else
        return "msgbox_vr_listen_bg_skincol.bmp"
      end
    elseif status == eVRStatus.click then
      return "msgbox_bg_skincol.bmp"
    else
      return "msgbox_bg_skincol.bmp"
    end
  end
  return "msgbox_bg_skincol.bmp"
end
 
sc_SetVRMapMessageboxBackground = function(status)
  local backgroundBmp = "map_msgboxbluehigh_spr_skincol.bmp"
  if MODEL.EXISTS.vr() then
    if MODEL.vr.ui.phase_running() then
      if MODEL.vr.engine_state() == 1 then
        backgroundBmp = "map_msgbox_vr_talk_spr_skincol.bmp"
      else
        backgroundBmp = "map_msgbox_vr_listen_spr_skincol.bmp"
      end
    elseif MODEL.lua.VRError() then
      backgroundBmp = "map_msgbox_vr_error_spr_skincol.bmp"
    end
  end
  return backgroundBmp
end
 
sc_SetCarModelPreview = function()
  ui_CarModelPreview.X = ui.spr_CarModelPreview.X
  ui_CarModelPreview.Y = ui.spr_CarModelPreview.Y
  ui_CarModelPreview.W = ui.spr_CarModelPreview.W
  ui_CarModelPreview.H = ui.spr_CarModelPreview.H
end
 